<?php
namespace Pinpoint\PackingSlips\Plugin\Sales\Block\Adminhtml\Order;

use Magento\Sales\Block\Adminhtml\Order\View as OrderView;
use Magento\Framework\UrlInterface;
use Magento\Framework\AuthorizationInterface;

/**
 * Class View
 * @package Pinpoint\PackingSlips\Plugin\Sales\Block\Adminhtml\Order
 */
class View
{
    /** @var \Magento\Framework\UrlInterface */
    protected $_urlBuilder;

    /** @var \Magento\Framework\AuthorizationInterface */
    protected $_authorization;

    /**
     * View constructor.
     * @param UrlInterface $url
     * @param AuthorizationInterface $authorization
     */
    public function __construct(
        UrlInterface $url,
        AuthorizationInterface $authorization
    ) {
        $this->_urlBuilder = $url;
        $this->_authorization = $authorization;
    }

    /**
     * @param OrderView $view
     */
    public function beforeSetLayout(OrderView $view) {
        $url = $this->_urlBuilder->getUrl('packingslips/generate', ['id' => $view->getOrderId()]);

        $view->addButton(
            'picking_slip_generate',
            [
                'label' => __('Create Packing Slip'),
                'class' => 'my-button',
                'onclick' => sprintf('setLocation("%s")', $url)
            ]
        );
    }
}